/**
 * Copyright &copy; 2015-2020 <a href="http://www.jeeplus.org/">JeePlus</a> All rights reserved.
 */
package com.jeeplus.modules.sg.financial.settlement.service;

import com.jeeplus.common.utils.StringUtils;
import com.jeeplus.core.persistence.Page;
import com.jeeplus.core.service.CrudService;
import com.jeeplus.modules.sg.financial.settlement.entity.MaintainData;
import com.jeeplus.modules.sg.financial.settlement.mapper.DataMaintenanceMapper;
import com.jeeplus.modules.sg.financial.settlement.util.ExcelWriter;
import org.apache.poi.ss.usermodel.Workbook;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import javax.servlet.http.HttpServletResponse;
import java.io.IOException;
import java.io.OutputStream;
import java.net.URLEncoder;
import java.util.ArrayList;
import java.util.List;


@Service
@Transactional(readOnly = true)
public class DataMaintenanceService extends CrudService<DataMaintenanceMapper, MaintainData> {

	@Autowired
	private DataMaintenanceMapper dataMaintenanceMapper;

	public MaintainData get(String id) {
		return super.get(id);
	}
	
	public List<MaintainData> findList(MaintainData maintainData) {
		return super.findList(maintainData);
	}
	
	public Page<MaintainData> findPage(Page<MaintainData> page, MaintainData maintainData) {
		return super.findPage(page, maintainData);
	}
	
	@Transactional(readOnly = false)
	public void save(MaintainData maintainData) {
		super.save(maintainData);
	}

	@Transactional(readOnly = false)
	public void saveList(List<MaintainData> list) {
		for(MaintainData maintainData : list){
			maintainData.preInsert();
		}
		dataMaintenanceMapper.insertList(list);
	}
	
	@Transactional(readOnly = false)
	public void delete(MaintainData maintainData) {
		super.delete(maintainData);
	}

	@Transactional(readOnly = false)
    public void deleteData(String projectId){
        dataMaintenanceMapper.deleteData(projectId);
    }

    //判断erp是否存在
    public List<String> getJudge(List<String> strings){
		Boolean flag = false;
		List<String> list = new ArrayList<>();//定义一个集合
		List<MaintainData> maintainDatas = dataMaintenanceMapper.findListMain();//得到维护表所有数据
		if (null!=strings&&strings.size()>0){
			for (MaintainData maintainData:maintainDatas){
				flag = true;
				for (String str:strings){
					if (maintainData.getProjectId().equals(str)){
						flag=false;
						break;
					}
				}
				if (flag){
					list.add(maintainData.getProjectId());
				}
			}
		}
		return list;
	}

	public void export(MaintainData maintainData , HttpServletResponse response){
		Workbook workbook = null;
		try {
			List<MaintainData> list = dataMaintenanceMapper.findList(maintainData);
			workbook = ExcelWriter.exportData(list);
			long time = System.currentTimeMillis();
			String outFile = time + ".xlsx";

			OutputStream outputStream = response.getOutputStream();
			response.reset();
			response.setHeader("Content-Disposition", "attachment;filename="+outFile);
			response.setContentType("application/vnd.ms-excel;charset=UTF-8");
			workbook.write(outputStream);
			outputStream.flush();
			outputStream.close();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
		}
        	}


	public void exportHeard( HttpServletResponse response){
		Workbook workbook = null;
		try {
			workbook = ExcelWriter.exportHeard();
			String str = URLEncoder.encode("数据维护导入模板.xlsx", "UTF8");
			OutputStream outputStream = response.getOutputStream();
			response.reset();
			response.setHeader("Content-Disposition", "attachment;filename="+str);
			response.setContentType("application/vnd.ms-excel;charset=UTF-8");
			workbook.write(outputStream);
			outputStream.flush();
			outputStream.close();
		} catch (Exception e) {
			e.printStackTrace();
		} finally {
		}
	}
	
}